#include <iostream>
#include <vector>
#include "Birthday.h"

int main()
{
    cout << "Creating Birthday variables ..." << endl;
    Birthday bd0;
    Birthday bd1(1981, 9, 2);
    Birthday bd2(1992, 5, 8);

    cout << endl << "Creating Birthday vector ..." << endl;
    vector<Birthday> birthdays;
    //birthdays.reserve(10);

    cout << "...  push_back(bd0) ..." << endl;
    birthdays.push_back(bd0);
    cout << "...  push_back(bd1) ..." << endl;
    birthdays.push_back(bd1);
    cout << "...  push_back(bd2) ..." << endl;
    birthdays.push_back(bd2);

    cout << endl << "Updating Birthday vector ..." << endl;
    birthdays[0].set_year(2010);
    birthdays[1].set_year(2011);
    birthdays[2].set_year(2012);

    cout << endl << "Printing Birthday variables ..." << endl;
    cout << bd0 << ", " << bd1 << ", " << bd2 << endl;

    cout << endl << "Printing Birthday vector ..." << endl;
    cout << birthdays[0] << ", " << birthdays[1] << ", " << birthdays[2] << endl;

    cout << endl << "Creating pointer vector ..." << endl;
    vector<Birthday *> bdptrs;
    bdptrs.push_back(new Birthday());
    bdptrs.push_back(new Birthday(3001, 9, 2));
    bdptrs.push_back(new Birthday(3002, 5, 8));

    cout << endl << "Printing pointer vector ..." << endl;
    cout << *bdptrs[0] << ", " << *bdptrs[1] << ", " << *bdptrs[2] << endl;

    cout << endl << "Deleting birthdays from pointer vector ..." << endl;
    for (int i = 0; i < bdptrs.size(); i++) delete bdptrs[i];

    cout << endl << "End of program!" << endl;
    return 0;
}
